#include <QGuiApplication>
#include <QQmlApplicationEngine>
#include <QQmlContext>

#include "country.h"
#include "countryfactory.h"

int main(int argc, char *argv[])
{
#if QT_VERSION < QT_VERSION_CHECK(6, 0, 0)
    QCoreApplication::setAttribute(Qt::AA_EnableHighDpiScaling);
#endif
    QGuiApplication app(argc, argv);

    QQmlApplicationEngine engine;
    const QUrl url(QStringLiteral("qrc:/main.qml"));
    QObject::connect(
        &engine,
        &QQmlApplicationEngine::objectCreated,
        &app,
        [url](QObject *obj, const QUrl &objUrl) {
            if (!obj && url == objUrl)
                QCoreApplication::exit(-1);
        },
        Qt::QueuedConnection);

    QList<Country*> countries = CountryFactory::loadFromJson(":/assets/data_en-GB.json");
    QList<QObject*> cc;
    for ( auto cr : countries)
        cc.append(static_cast<QObject*>(cr));
    engine.rootContext()->setContextProperty("countries", QVariant::fromValue(cc));
    qmlRegisterType<Country>("I.hate.dictators",1,0,"CountryType" );

    engine.load(url);

    return app.exec();
}
